VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsSysTrayRefresh"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'Messagekonstante
Private Const WM_MOUSEMOVE = &H200

'Strucktur mit den Fensterabmaen
Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type
Dim hSystray As Long

Private Declare Function GetVersion Lib "kernel32.dll" () As Long
Private Declare Function FindWindowEx Lib "user32" Alias "FindWindowExA" (ByVal hWnd1 As Long, ByVal hWnd2 As Long, ByVal lpsz1 As String, ByVal lpsz2 As String) As Long
Private Declare Function GetClientRect Lib "user32.dll" (ByVal hWnd As Long, lpRect As RECT) As Long
Private Declare Function FindWindow Lib "user32.dll" Alias "FindWindowA" (ByVal lpClassName As String, ByVal lpWindowName As String) As Long
Private Declare Function SendMessage Lib "user32.dll" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long


Private Function Refresh(ByVal hTray As Long) As Boolean
Dim x As Long, rRect As RECT, z As Long

If hTray = 0 Then Exit Function
'Gre des Fensters ermitteln
x = GetClientRect(hTray, rRect)

'Zeilenweise durchgehen
For z = 0 To (rRect.Bottom / 20) - 1
    'zu jerder x Position ein MouseMove senden
    For x = 0 To rRect.Right
        SendMessage hTray, WM_MOUSEMOVE, 0, ByVal ((((z * 20) + 10) * &H10000) Or x)
    Next
Next
Refresh = True

End Function
Private Function FindSysTray() As Long
Dim h1 As Long, h2 As Long, h3 As Long
'Handle vom Tray suchen
h1 = FindWindow("Shell_TrayWnd", vbNullString)
If h1 <> 0 Then
    'Handle vom TrayNotify ermitteln
    h2 = FindWindowEx(h1, 0, "TrayNotifyWnd", vbNullString)
    If GetVersion >= &H401 Then
        If h2 <> 0 Then
            'Handle von der Toolbar ermitteln
            h3 = FindWindowEx(h2, 0, "ToolbarWindow32", vbNullString)
            FindSysTray = h3
        End If
    Else
        FindSysTray = h2
    End If
End If

End Function
Public Function SysTrayRefresh() As Boolean

'Fensterhandle vom Systray ermitteln
hSystray = FindSysTray
'Systray refreshen
If Refresh(hSystray) Then SysTrayRefresh = True
End Function
Property Get hWnd() As Long
hWnd = hSystray
End Property
